commit d2f2529e3f1911788af4802c8d4bac89f74dffc0
Author: Václav Jirák <jirakv95@gmail.com>
Date:   Wed Jun 5 15:05:06 2019 +0200

    Added units to vacation info component

diff --git a/webapp/src/app/employees/edit-employee-dialog/edit-employee-dialog.component.html b/webapp/src/app/employees/edit-employee-dialog/edit-employee-dialog.component.html
index 77604ee..9bdf277 100644
--- a/webapp/src/app/employees/edit-employee-dialog/edit-employee-dialog.component.html
+++ b/webapp/src/app/employees/edit-employee-dialog/edit-employee-dialog.component.html
@@ -29,7 +29,7 @@
         type="number"
         placeholder="{{'editEmployee.setSickdays' | translate}}"
         min="0"
-        step="0.5"
+        step="1"
         [(ngModel)]="_sickDaysCount"
       >
     </mat-form-field>
@@ -43,7 +43,7 @@
       type="number"
       placeholder="{{'editEmployee.addVacation' | translate}}"
       min="0"
-      step="0.5"
+      step="1"
       [(ngModel)]="_addVacationHoursCount"
     >
   </mat-form-field>
diff --git a/webapp/src/app/vacation-info/vacation-info.component.html b/webapp/src/app/vacation-info/vacation-info.component.html
index 176d8a0..6938cf3 100644
--- a/webapp/src/app/vacation-info/vacation-info.component.html
+++ b/webapp/src/app/vacation-info/vacation-info.component.html
@@ -1,17 +1,19 @@
-<div class="days-off-info-container">
+<div class="vacation-info-container">
 
-  <div class="component-header" translate>
-    <span translate>daysOffInfo.remaining</span>
+  <div class="component-header">
+    <span translate>{{ 'vacationInfo.header' | translate }}</span>
   </div>
 
-  <div class="days-off-type-container">
-    <span class="days-off-remaining">{{extraVacationRemaining}}</span>
-    <span class="days-off-type" translate>vacationType.vacation</span>
+  <div class="vacation-type-container">
+    <span class="vacation-remaining">{{extraVacationRemaining}}</span>
+    <span class="units">{{ 'vacationInfo.hours' | translate }}</span>
+    <span class="vacation-type" translate>vacationType.vacation</span>
   </div>
 
-  <div class="days-off-type-container">
-    <span class="days-off-remaining">{{sickDaysRemaining}}</span>
-    <span class="days-off-type" translate>vacationType.sickday</span>
+  <div class="vacation-type-container">
+    <span class="vacation-remaining">{{sickDaysRemaining}}</span>
+    <span class="units">{{ 'vacationInfo.days' | translate }}</span>
+    <span class="vacation-type" translate>vacationType.sickday</span>
   </div>
 
 </div>
diff --git a/webapp/src/app/vacation-info/vacation-info.component.sass b/webapp/src/app/vacation-info/vacation-info.component.sass
index c0e4975..55fefdf 100644
--- a/webapp/src/app/vacation-info/vacation-info.component.sass
+++ b/webapp/src/app/vacation-info/vacation-info.component.sass
@@ -1,18 +1,23 @@
 @import '../../common-styles/basic-component'
 
-.days-off-info-container
+.vacation-info-container
   @extend .basic-component
 
-.days-off-type-container
+.vacation-type-container
   border-bottom: 1px solid gainsboro
   padding-left: 20px
 
-.days-off-remaining
+.vacation-remaining
   color: green
   font-size: 30px
   font-weight: bold
 
-.days-off-type
+.vacation-type
   color: black
   font-weight: bold
   display: block
+
+.units
+  color: grey
+  font-size: 10px
+  font-style: italic
diff --git a/webapp/src/assets/i18n/cs.json b/webapp/src/assets/i18n/cs.json
index 63ecd81..50e50ff 100644
--- a/webapp/src/assets/i18n/cs.json
+++ b/webapp/src/assets/i18n/cs.json
@@ -1,6 +1,8 @@
 {
-  "daysOffInfo": {
-    "remaining": "Zbývající dovolená"
+  "vacationInfo": {
+    "header": "Zbývající dovolená",
+    "days": "dní",
+    "hours": "hodin"
   },
   "userApproval": {
     "headline": "Schvalování uživatelů",
diff --git a/webapp/src/assets/i18n/en.json b/webapp/src/assets/i18n/en.json
index b7b333c..2fe3834 100644
--- a/webapp/src/assets/i18n/en.json
+++ b/webapp/src/assets/i18n/en.json
@@ -1,6 +1,8 @@
 {
-  "daysOffInfo": {
-    "remaining": "Vacation remaining"
+  "vacationInfo": {
+    "header": "Vacation remaining",
+    "days": "days",
+    "hours": "hours"
   },
   "userApproval": {
     "headline": "User approval",